
if(typeof(mimace)!="undefined"){
	delete mimace;
}
var mimace={
	temp			:	"",		//临时全局变量
	click_type		:	"",		//为了防止冒泡
	default_model	:	"",		//默认模式、类型
	click			:	function(ev, type){
		if(type && type == "button"){ 		//按钮
			if(this.click_type=="menu"){
				this.click_type="";
				return false;
			}		
		} else { 							//菜单
			this.default_model=ev.target.getAttribute("id");
			
			//修改按钮的tip文字
			document.getElementById("mimace-tool-bar").setAttribute("tooltiptext", ev.target.getAttribute("label"));
			this.click_type="menu";
		}
		
		if(this.default_model){
			var badge_text=this.getBadge(this.default_model);
			if( !badge_text ){		
				var open_url="https://mimace.com/v1/login";	//打开登录密码册页面
				if(this.default_model=="logout_page"){
					open_url="https://mimace.com/v1/logout";	//退出密码册
				}
				//window.open(open_url);
				var linka = window.content.document.createElement("a");
				linka.setAttribute("href", open_url);
				linka.setAttribute("target", "_blank");
				window.content.document.body.appendChild(linka);
				try {		
					var ev = window.content.document.createEvent('MouseEvents');
					ev.initEvent('click', false, true);
					linka.dispatchEvent(ev);
				} catch(e) {
					window.open(open_url);	
					//在新窗口打开的，但window.content.window.open(open_url);会被阻止弹出
				}
				return false;
			}
			
			this.setDefaultModel(this.default_model);
			this.showBadge(badge_text);
			
			var js_code="https://mimace.com/v1/js/"+this.default_model
				+"/hostname/"+encodeURIComponent(window.content.location.hostname)
				+"/browser/firefox/t/"+String(new Date().getTime());
			
			var e = window.content.document.createElement("script");
			e.setAttribute("language","JavaScript");
			e.setAttribute("charset","utf-8");
			e.setAttribute("src", js_code);
			window.content.document.body.appendChild(e);
		}
	},
	
	//获取默认的模式
	getDefaultModel	:	function(){
		return Application.prefs.getValue("extensions.MiMaCe.com.defaultModel", "no");
	},
	//设置默认模式的值
	setDefaultModel	:	function(val){
		try{
			Application.prefs.setValue("extensions.MiMaCe.com.defaultModel", val);
		}catch(e){}
	},

	//显示按钮的右下角标志
	showBadge	:	function(badge_text){
		if(badge_text){
			var badge_dom=document.getElementById("badge_text");
			badge_dom.style.display="inline";		
			badge_dom.value=badge_text;
			
			document.getElementById("mimace-tool-bar").style.cursor="pointer";
		}
	},

	//隐藏按钮的右下角标志
	hideBadge	:	function(){
		try{
			document.getElementById("badge_text").style.display="none";
			document.getElementById("mimace-tool-bar").style.cursor="default";
		} catch(e){ }
	},

	//根据default_model获取对应标志信息
	getBadge	:	function(default_model){
		var badge_text="";
		switch(default_model){
			case "unitary_login":
				badge_text = "=";
			break;
			case "unitary_fill":
				badge_text = "V";
			break;
			case "show_account":
				badge_text = "~";
			break;
			case "show_account_list":
				badge_text = "L";
			break;
			case "add_account":
				badge_text = "+";
			break;
			case "show_panel":
				badge_text = "P";
			break;
			default:
			break;
		}
		return badge_text;
	},

	//设置按钮为TopTool
	setTopTool	:	function(){
		//check whether user has manually removed the toolbar buttons
		var navbar = document.getElementById("nav-bar");
		if(navbar != null) {
			navbar.addEventListener("DOMAttrModified", function(event) {
				if(event.type == "DOMAttrModified" && event.attrName == "currentset") {
					if(event.newValue.indexOf("mimace-button-box") == -1) {
						mimace.setMimaceToolPref(true);
					} else {
						mimace.setMimaceToolPref(false);
					}
				}
			}, false);
		}

		mimace.insertNavBar();
	},

	// 获取 mimace 的 TopTool 是否隐藏的设置值
	getMimaceToolPref	:	function(){
		return Application.prefs.getValue("extensions.MiMaCe.com.manuallyRemovedMimaceToolButton", false);
	},

	// 设置 mimace 的 TopTool 是否隐藏
	setMimaceToolPref	:	function(val){
		try {
			Application.prefs.setValue("extensions.MiMaCe.com.manuallyRemovedMimaceToolButton", val);
		} catch(e) {
		}
	},

	//把按钮插入到nav-bar中显示（由配置信息决定）
	insertNavBar	:	function(){
		try {
			var firefoxnav = document.getElementById("nav-bar");
			var newSet = firefoxnav.currentSet;
			// 获取设置
			var manuallyRemovedMimaceToolButton = this.getMimaceToolPref();
			
			if(newSet.indexOf("mimace-button-box") == -1 && manuallyRemovedMimaceToolButton == false) {
			///if(1) {
				newSet = newSet.replace(",,", ",");
				// 绑定指定按钮到 nav-bar 里
				if(newSet.indexOf("search-container") != -1){				// 搜索框之后
					newSet = newSet.replace(/search-container/, "search-container,mimace-button-box");
				} else if (newSet.indexOf("urlbar-container") != -1){		// 地址栏之后
					newSet = newSet.replace(/urlbar-container/, "urlbar-container,mimace-button-box");
				} else {	// 追加到最后
					newSet = newSet + ",mimace-button-box";
				}
				firefoxnav.setAttribute("currentset", newSet);	
				firefoxnav.currentSet = newSet;
				document.persist("nav-bar", "currentset");

				try {
					BrowserToolboxCustomizeDone(true);
				} catch(ex) {
				}
			}
		} catch(e) {
		}
	}
};

window.addEventListener("load", function(){ 
	//alert( String(new Date().getTime()) );
	//根据配置来设置按钮是否显示在nav-bar中
	mimace.setTopTool();
	
	//显示标志和获取默认模式的值
	mimace.temp=mimace.getDefaultModel();
	if(mimace.temp && mimace.temp != "no"){
		mimace.default_model=mimace.temp;		//必须，获取默认模式的值
		var badge_text=mimace.getBadge(mimace.default_model);
		mimace.showBadge( badge_text );
	}
}, false);
